package ajax.login.service;

import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;

import ajax.login.dao.UserDao;
import ajax.login.entity.User;
import ajax.login.security.LoginToken;

public class UserSevice implements UserDetailsService {

	private UserDao userDao;

	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	@Override
	public UserDetails loadUserByUsername(String username)
		throws UsernameNotFoundException {

		User user = userDao.selectById(username);
		if (user == null) {
			throw new UsernameNotFoundException(username);
		}

		return new LoginToken(user);
	}

}
